<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY sp " ">
]>

<!-- contributed by Sigfrid Lundberg, sigfrid.lundberg@lub.lu.se -->
<!-- triggered by an xml document like this: -->
<!--

<?xml version="1.0" encoding="ISO-8859-1" standalone="yes"?>
<site-map creator="sigge" created="2004-01-08, 13:40:00" modifier="sigge"
	modified="2004-01-08, 13:45:00">
<title xml:lang="sv">\x{00D6}versikt \x{00F6}ver SVEP-projektets webb</title>
<creator email="sigfrid.lundberg@lub.lu.se">Sigfrid Lundberg</creator>
</site-map>

-->


<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:portcom="http://www.indexdata.dk/TKL"
    exclude-result-prefixes="portcom"
    version="1.0">

  <xsl:import href="tkl-file://interface.xsl"/>
  <xsl:include href="tkl-file://news.xsl"/>

  <xsl:output method="xml"
    media-type="text/html"
    doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"

doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
    encoding="utf-8"
    />

  <xsl:param name="tkl_authenticated"/>

  <xsl:template match="/site-map">
    <xsl:call-template name="main-page"/>
  </xsl:template>


  <xsl:template name="main-news-content">
    <xsl:call-template name="read-news"/>
  </xsl:template>

  <xsl:template name="main-body">
    <xsl:variable name="map">
      <xsl:for-each select="document(concat('tkl-find://',
        '?path=/',
	'&amp;mask=index.tkl',
	'&amp;select=title',
	'&amp;level=5'))">
	<xsl:copy-of select="."/>
      </xsl:for-each>
    </xsl:variable>

    <xsl:call-template name="insert-path"/>

    <dl>
    <xsl:apply-templates select="$map" />
    </dl>
  </xsl:template>

  <xsl:template match="dir">
    <xsl:apply-templates select="file">
      <xsl:sort select="title"/>
    </xsl:apply-templates>
    <xsl:if test="dir">
      <xsl:element name="dd">
	<xsl:element name="dl">
	  <xsl:apply-templates select="dir">
	    <xsl:sort select="file/title"/>
	  </xsl:apply-templates>
	</xsl:element>
      </xsl:element>
    </xsl:if>
  </xsl:template>

  <xsl:template match="file">
    <xsl:if test="title">
      <xsl:element name="dt">
	<xsl:element name="a">
	  <xsl:attribute name="href">
	    <xsl:value-of select="@path"/>
	  </xsl:attribute>
	  <xsl:value-of select="title"/>
	</xsl:element>
      </xsl:element>
    </xsl:if>
  </xsl:template>


</xsl:stylesheet>

<!--
But there was a bug... The links didn't work

>> <xsl:template match="file">
>>> >     <xsl:if test="title">
>>> >       <xsl:element name="dt">
>>> >         <xsl:element name="a">
>>> >           <xsl:attribute name="href">
>>> >             <xsl:value-of select="@path"/>


Needs to be

   <xsl:value-of select="substring-after(@path,'/')"/>
-->
